#include "tlc1543.h"
#include "delay.h"

/*
STM32F10X<=>TLC1543
PE4=>CS
PE3=>EOC
PE0=>IOCLK
PE2=>DOUT
PE1=>ADDR
*/
void tlc1543_gpioinit(void)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE,ENABLE);

	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Pin=GPIO_Pin_4|GPIO_Pin_0|GPIO_Pin_1;	
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOE,&GPIO_InitStruct);

	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_IPU;
	GPIO_InitStruct.GPIO_Pin=GPIO_Pin_3|GPIO_Pin_2;	
	GPIO_Init(GPIOE,&GPIO_InitStruct);

}

unsigned int ADCSelChannel(unsigned char Channel)
{
	unsigned int ConvertValue;
	unsigned char i, Chan;
	unsigned char ConvertValueL, ConvertValueH;
	unsigned char delay;
 
 	ConvertValueL = ConvertValueH = 0; 
 	delay = 0;
	if(GPIO_ReadInputDataBit(GPIOE,GPIO_Pin_3))
	{
		GPIO_ResetBits(GPIOE,GPIO_Pin_0);
		GPIO_SetBits(GPIOE,GPIO_Pin_4);
		delay_us(2);//Wait2us;
		GPIO_ResetBits(GPIOE,GPIO_Pin_4);
		delay_us(2);//Wait2us;
		Channel = Channel << 4;
		for (i = 0; i < 4; i ++) 
		{
			Chan = Channel;
			Chan = Chan >> 7;
			if(Chan)
				GPIO_SetBits(GPIOE,GPIO_Pin_1);
			else
				GPIO_ResetBits(GPIOE,GPIO_Pin_1);
			delay_us(2);//Wait2us;
			GPIO_SetBits(GPIOE,GPIO_Pin_0);
			GPIO_ResetBits(GPIOE,GPIO_Pin_0);
			Channel = Channel << 1;
		}
		for (i = 0; i < 6;i ++) 
		{
			GPIO_SetBits(GPIOE,GPIO_Pin_0);
			GPIO_ResetBits(GPIOE,GPIO_Pin_0);
		}
		GPIO_SetBits(GPIOA,GPIO_Pin_4);

		while ((!GPIO_ReadInputDataBit(GPIOE,GPIO_Pin_3)) && (delay < 10))
		{
			delay_us(10);//Wait10us;
			delay ++;
		}
		if (delay == 10)
		{
			return (0xFFFF);
		}
		else
		{
			delay_us(10);//Wait10us;
			GPIO_ResetBits(GPIOE,GPIO_Pin_0);
			GPIO_SetBits(GPIOE,GPIO_Pin_4);
			delay_us(1);//Wait1us;
			GPIO_ResetBits(GPIOE,GPIO_Pin_4);
			delay_us(1);//Wait1us;
			for (i = 0; i < 2; i ++) 
			{
				GPIO_SetBits(GPIOE,GPIO_Pin_0);
				ConvertValueH <<= 1;
				if(GPIO_ReadInputDataBit(GPIOE,GPIO_Pin_2))
				ConvertValueH |= 0x1;
				GPIO_ResetBits(GPIOE,GPIO_Pin_0);
				delay_us(1);//Wait1us;
			} 
			for (i = 0; i < 8; i ++) 
			{
				GPIO_SetBits(GPIOE,GPIO_Pin_0);
				ConvertValueL <<= 1;
				if(GPIO_ReadInputDataBit(GPIOE,GPIO_Pin_2))
				ConvertValueL |= 0x1;
				GPIO_ResetBits(GPIOE,GPIO_Pin_0);
				delay_us(1);//Wait1us;
			} 
			GPIO_SetBits(GPIOE,GPIO_Pin_4);
			ConvertValue = ConvertValueH;
			ConvertValue <<= 8;
			ConvertValue |= ConvertValueL;
			return ConvertValue; 
		}
	}
}


